#!/bin/sh
#
# Copyright (c) 2019 SUSE LINUX
#
# please send bugfixes or comments to http://www.suse.com/feedback.

#
# paranoia settings
#
umask 022
PATH=/sbin:/bin:/usr/sbin:/usr/bin
export PATH

if [ -f /etc/sysconfig/btrfsmaintenance ] ; then
    . /etc/sysconfig/btrfsmaintenance
fi

if [ -f /etc/default/btrfsmaintenance ] ; then
    . /etc/default/btrfsmaintenance
fi

btrfs_fsid() {
	btrfs filesystem show "$1" | sed -n -e '/uuid:/ {s/^.*uuid: //;p }'
}

run_task() {
	MNT="${@:$#}"
	UUID=$(btrfs_fsid "$MNT")

	if test "$BTRFS_ALLOW_CONCURRENCY" = "true"; then
		"$@"
	else
		/usr/bin/flock /run/btrfs-maintenance-running."$UUID" "$@"
	fi
}
